//
//  AppDelegate.m
//  Backlight
//
//  Created by MisterBiro on 6/12/17.
//  Copyright © 2017 MisterBiro. All rights reserved.
//

#import "AppDelegate.h"
#import "SliderView.h"

@interface AppDelegate ()
@property (strong) IBOutlet SliderView *mySliderView;
@end

@implementation AppDelegate

//NSNotificationCenter *nc;
NSDistributedNotificationCenter *dnCenter;

NSStatusItem *statusItem;
NSMenu *statusMenu;

double brightness;

bool listenUnlock;
bool listenScreensaver;
//bool listenWake;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    // Insert code here to initialize your application
    
    listenUnlock = true;
    listenScreensaver = true;
    //listenWake = true;
    
    brightness = 0.5;
    
    [NSApp setActivationPolicy:NSApplicationActivationPolicyAccessory ];
    
    
    dnCenter = [NSDistributedNotificationCenter defaultCenter];
    
    /*nc = [[NSWorkspace  sharedWorkspace] notificationCenter];

    [nc addObserver: self
                        selector: @selector(receiveWakeNote:)
                            name: NSWorkspaceDidWakeNotification
                          object: nil];*/
    

    [dnCenter addObserver: self
               selector:    @selector(handleNotification:)
                   name:        @"com.apple.screensaver.didstop"
                 object:      nil
     ];
    
    [dnCenter addObserver: self
               selector:    @selector(handleNotification:)
                   name:        @"com.apple.screenIsUnlocked"
                 object:      nil
     ];
    
    NSMenuItem *tItem = nil;
    
    statusMenu = [[NSMenu alloc] initWithTitle:@""];
    [statusMenu setAutoenablesItems:NO];

    [statusMenu addItemWithTitle:@"BLANK" action:nil keyEquivalent:@""];
    [statusMenu addItem:[NSMenuItem separatorItem]];
    tItem = [statusMenu addItemWithTitle:@"Screensaver..." action:@selector(selectNotificationScreensaver:) keyEquivalent:@""];
    [tItem setState:NSOnState];
    
    tItem = [statusMenu addItemWithTitle:@"Unlock..." action:@selector(selectNotificationUnlock:) keyEquivalent:@""];
    [tItem setState:NSOnState];
    
    /*tItem = [statusMenu addItemWithTitle:@"Wake..." action:@selector(selectNotificationWake:) keyEquivalent:@""];
    [tItem setState:NSOnState];*/
    
    [statusMenu addItem:[NSMenuItem separatorItem]];
    
    tItem = [[NSMenuItem alloc] initWithTitle:@"Brightness Slider" action:nil keyEquivalent:@""];
    tItem.enabled = YES;
    tItem.view = self.mySliderView;
    
    tItem = [statusMenu addItemWithTitle:@"Quit" action:@selector(terminate:) keyEquivalent:@"q"];
    
    [tItem setKeyEquivalentModifierMask:NSEventModifierFlagCommand];
    
    NSStatusBar *statusBar = [NSStatusBar systemStatusBar];
    statusItem = [statusBar statusItemWithLength:NSVariableStatusItemLength];
    
    [statusItem setImage:[NSImage imageNamed:@"Icon.png"]];
    [statusItem setToolTip:@"Backlight Contol"];
    [statusItem setHighlightMode:YES];
    [statusItem setMenu:statusMenu];
    
    NSData *menuCopyData = [NSArchiver archivedDataWithRootObject:statusMenu];
    id menuCopy = [NSUnarchiver unarchiveObjectWithData:menuCopyData];
    [menuCopy removeItemAtIndex:0];
    [self addSliderMenuItemView:menuCopy];
    statusItem.menu = menuCopy;
    
    [self setBrightness:brightness];
}

/*- (void) receiveWakeNote: (NSNotification*) note
{
    NSLog(@"receiveWakeNote: %@", [note name]);
    if(listenWake == true)
        [self setBrightness:brightness];
}*/

- (void) selectNotificationScreensaver:(NSMenuItem *)statusItem {
    
    if ([statusItem state] == NSOnState) {
        [statusItem setState:NSOffState];
        listenScreensaver = false;
    }
    else {
        [statusItem setState:NSOnState];
        listenScreensaver = true;
    }
        
}

- (void) selectNotificationUnlock:(NSMenuItem *)statusItem {
    
    if ([statusItem state] == NSOnState) {
        [statusItem setState:NSOffState];
        listenUnlock = false;
    }
    else {
        [statusItem setState:NSOnState];
        listenUnlock = true;
    }
}

/*- (void) selectNotificationWake:(NSMenuItem *)statusItem {
    
    if ([statusItem state] == NSOnState) {
        [statusItem setState:NSOffState];
        listenWake = false;
    }
    else {
        [statusItem setState:NSOnState];
        listenWake = true;
    }
}*/

- (void) handleNotification:(NSNotification *)notification {

    if(([notification.name isEqualToString:@"com.apple.screenIsUnlocked"]) && (listenUnlock == true))
        [self setBrightness:brightness];
    
    if(([notification.name isEqualToString:@"com.apple.screensaver.didstop"]) && (listenScreensaver == true))
        [self setBrightness:brightness];
}

- (void)applicationWillTerminate:(NSNotification *)aNotification {
    // Insert code here to tear down your application
    [dnCenter removeObserver:self];
}

- (void)addSliderMenuItemView:(NSMenu *)menu
{
    NSData *viewCopyData = [NSArchiver archivedDataWithRootObject:self.mySliderView];viewCopyData = [NSArchiver archivedDataWithRootObject:self.mySliderView];
    id viewCopy = [NSUnarchiver unarchiveObjectWithData:viewCopyData];
    NSMenuItem *menuItem = [menu itemAtIndex:0];
    menuItem.view = viewCopy;
    menuItem.target = self;
}

- (IBAction)sliderValueChanged:(NSSlider *)sender {
    NSInteger senderValue = sender.integerValue;
    
    if(senderValue > 95)
        senderValue = 95;
    
    if(senderValue < 10)
        senderValue = 10;
    
    brightness = senderValue/100.0;

    [self setBrightness:brightness];
}

- (void) setBrightness: (float) level
{
    io_iterator_t iterator;
    kern_return_t result = IOServiceGetMatchingServices(kIOMasterPortDefault,
                                                        IOServiceMatching("IODisplayConnect"),
                                                        &iterator);
    
    if (result == kIOReturnSuccess)
    {
        io_object_t service;
        while ((service = IOIteratorNext(iterator))) {
            IODisplaySetFloatParameter(service, kNilOptions, CFSTR(kIODisplayBrightnessKey), level);
            IOObjectRelease(service);
            //return;
        }
        
    }
}

@end
